using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.GoodsReceive.Cqrs;

public record DeleteGoodsReceiveItemCommand(string Id) : IRequest<bool>;

public class DeleteGoodsReceiveItemHandler : IRequestHandler<DeleteGoodsReceiveItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteGoodsReceiveItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteGoodsReceiveItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}